# Wisp - Warframe Survivor Mod

The floating riftwalker, Wisp, has floated through one too many dimensions, Now she has appeared in your selection of playable characters in Risk Of Rain 2.

Network compatible.

If there are any issues **technical issues** (bugs, moves not working as intended, achievements etc.), please message me on discord **@Ethanol10#6656**.

For any **balance changes** specifically, please contact **@SeizaKokoro#1067** on discord.

IF YOU HAVE USED THE MOD BEFORE v3.0.0, PLEASE DELETE THE CONFIG FILE!

## Mod Interoperability List
- StandaloneAncientScepter
- ThinkInvisible's ClassicItems AncientScepter
- RiskUI* (Really just making sure that it works nicely with it, nothing special)

## Latest Changes

- v3.0.5 -> Removing Dependency for Network Timed Buffs

- v3.0.0 -> New Skills and Elite Type!
  - Nullifier Elites have been added!
    - Creates a sphere that removes access to your 2nd to 4th skill.
    - Buffs enemies with armor within range.
    - Elite Equipment buffs teammates and drones within range of your bubble, while granting you a 20% chance to block damage.
  - Nukor has been added!
    - Shots bounce of enemies dealing damage on each bounce
  - New skin has been added!

## Screenshots
<img src="https://cdn.discordapp.com/attachments/399901440023330816/959349491851493387/unknown.png"/>

<img src="https://cdn.discordapp.com/attachments/399901440023330816/959116894038810645/unknown.png"/>


## Abilities
### Passive:
<img width="200" src="https://cdn.discordapp.com/attachments/399901440023330816/959362291239882752/texWispIconNoOutline.png"/>

Wisp is immune to fall damage, but will be stunned for 1 second when the fall damage would've taken 33% or more of your health.

Wisp also spawns with her signature equipment, 「 Sol Gate 」, which maybe swapped for any other equipment.


### Primary: Fulmin
<img width="200" src="https://cdn.discordapp.com/attachments/399901440023330816/960476180820140052/unknown.png"/>

Fire a gun. Switch between fully automatic and semi automatic firing modes using the [Mouse Wheel] or [DPad Down].

#### **[ Fulmin: Semi ]** 

Fire 5 bullets in a tight spread for 200% each bullet.
Consumes 10 stocks per shot.

#### **[ Fulmin: Auto ]** 

Fire an automatic weapon for 65% damage.
Consumes 1 stock per shot.


### Secondary: Reservoirs
<img width="200" src="https://cdn.discordapp.com/attachments/399901440023330816/960476207827279882/unknown.png"/>

Choose and summon a 「　Vitality / Haste　」 Reservior filled with motes that attach to and aid Wisp and her allies. You may only place 6 reservoirs of any type per stage. **Tap** to switch between types, and **Hold** to place a mote down.

#### **[ Reservoirs: Vitality ]**

Place down a mote that increases maximum health by 300 health, while also granting an extra 30hp/s regen. The buff lasts for 30 seconds.

#### **[ Reservoirs: Haste ]**

Place down a mote that boosts attack speed by 1.75x, while also granting a 1.4x increase in movement speed. The buff lasts for 30 seconds.


### Utility: Will-O-Wisp
<img width="200" src="https://cdn.discordapp.com/attachments/399901440023330816/960477242989871144/unknown.png"/>

Cast forward a Spectral Image of Wisp and promptly turn invisible for a short time. Reactivate to travel to its location.


### Special: Breach Surge
<img width="200" src="https://cdn.discordapp.com/attachments/399901440023330816/960476240467329054/unknown.png"/>

Stunning. Open a dimensional breach to overwhelm nearby enemies. Enemies in range are debuffed and receive 2x damage from all sources for 8 seconds.


### Equipment: Sol Gate
<img width="200" src="https://cdn.discordapp.com/attachments/399901440023330816/960476271027036211/unknown.png"/>

Open a portal to the sun to irradiate enemies with a devastating beam of pure solar plasma. Deal 100% damage per tick for 10 seconds. Has a 40% chance per tick to set fire to enemies. Cancelled when any move is performed.

## Support me on Ko-fi! 
There's no need to pay for mods, but a coffee would be nice once in awhile!

<a href="https://ko-fi.com/ethanol10" target="_blank">
  <img width="400" src="https://cdn.discordapp.com/attachments/928130606662049892/952521134526590996/unknown.png"/>
</a>

## Version History:
<details>
<summary>Click to expand patch notes:</summary>

- v3.0.4 
  - Added Mod Icon to RoO
  - Applying fixes to potential NRE on Nullifier debuff.
- v3.0.3 -> R2API Submodules support.
- v3.0.2 -> Bug Fixes:
  - Upon picking up a Blessing Of Parvos (Nullifier Equipment), the player would have had unintentionally been thrown upwards when the bubble touched a jumppad/geyser. This has been fixed to not register with the geyser.
- v3.0.1 -> Minor Changes:
  - Nullifier Config has been added that allows you to disable their spawn through the config. This option can be selected in RiskOfOptions.
- v3.0.0 -> New Skills and Elite Type!
  - Nullifier Elites have been added!
    - Creates a sphere that removes access to your 2nd to 4th skill.
    - Buffs enemies with armor within range.
    - Elite Equipment buffs teammates and drones within range of your bubble, while granting you a 20% chance to block damage.
  - Nukor has been added!
    - Shots bounce of enemies dealing damage on each bounce
  - New skin has been added!
- v2.0.3 -> Update to the following:
  - Forgot to copy the Shield Material causing everyone with a shield to turn orange. Should be blue again.
- v2.0.2 -> Changes to the following:
  - Changed the positioning of the text when utilising RiskUI
  - Changed Wisp's weight to prevent wisp from being launched extremely far in certain circumstances.
  - Made Breach Surge teleport trigger when you hold the button down while looking at the mote.
- v2.0.1 -> Fixes to the following: Changed sound name on Fall Stun, as Sound name was conflicting with Enforcer.
- v2.0.0 -> Major update!
  - 3 new moves ready to be unleashed!
  - New Skin!
  - 4 new achivements!
  - Additional bug fixes and changes:
    - Removal of MiniRPCLib as a dependency.
    - Smoothed out the mote seeds when they travel to Allies and as they travel around you.
    - Added EmoteAPI support!
    - Added Teleportation to Mote flower when Breach Surge is equipped.
    - Nerfed Fulmin: Auto proc-coefficient from 2.0 -> 1.25
    - Reduced Audio volume slightly
- v1.0.8 -> Changes to the following:
  - Added back Classic Items, made Networkbufftimers a hard dependency, fixed scepters being stupid.
  - Added ring type mote into config, please reset your config by wiping it. By Default, a Sphere is used.  
- v1.0.7 -> Removed ClassicItems' support. It was causing problems when trying to load the scepter skills in while trying to handle StandaloneAncientScepter.
- v1.0.6 -> Added the following:
  - Added some networked prefabs into the networking list, it should work better with "WhatAmILookingAt."
  - Fixed Achievements not working.
  - Added StandaloneAncientScepter Support back into the mix.
- v1.0.5 -> Left the Item displays on accidentally without changing anything. Removed. Sol Gate still works as it should.
- v1.0.4 -> Changed the following: 
  - Nova Achievement completely reworked -> Sun Destroyer: Kill 5 Grandparents as Wisp.
    - This should completely stop the Void Cradles/Blood Shrine errors.
  - Changed dependancy for Scepter, should work with ThinkInvisible's Classic Items.
  - Added Sol Gate as an Item Display.
- v1.0.3 -> Attempted fixes to the following:
  - Void achievement changed from "Kill Voidling" to "Escape the Planetarium."
  - Fixed Wisp taking fall damage when fall damage would be lethal (e.g Artifact of Frailty).
  - Sol Gate beam effect should move smoother.
- v1.0.2 -> Attempted fixes to the following: 
  - Attempting to fix NRE on Will-O-Wisp destroy with more Null checks. Should stop wisp from getting stuck and blasting noise into your headphones
  - Fixed luck affecting Sol Gate fire procs. Should actually proc MORE with more luck.
  - Fixed Attack Speeds less than 1 affecting auto-reload mechanic.
- v1.0.1 -> Attempted fixes to the following:
  - Nova Achievement was breaking health required shrines (Void cradle/Blood Shrine). Added more null checks to avoid this issue. Please contact me (Ethanol 10) if you encounter this issue.
  - Tags above abilities were messing up in multiplayer. An authority check was applied, which should mitigate how many times it's printed.
  - Straightened Sol Gate laser and pushed it up a bit to match the center of the screen. Also reduced what it should bounce off.
  - Lowered Volume across the board. Should be 2db at max volume.
- v1.0.0 -> Initial release

</details>


## Future Plans

<!> Add alternate skins. (Must get approval from tennogen artists first)

<!> Add Wisp Prime skin. (When it eventually comes out)

## Known Issues

<!> When using Will-O-Wisp, the Will-o-wisp minion model can face the wrong way in multiplayer.

<!> Gloom audio does not play correctly when casting the ability.

<!> Will-O-Wisp uses default skin all the time.

<!> Fulmin model is wack in terms of placement on the model.

<!> Ragdoll is also wack.

<!> There are some instances where D-Pad down does not change the firing mode.

## Credits

- SeizaKokoro#1067 - The mod was their brainchild - Commissioned this mod to be made. 
- Rob's Henry mod - Used as an early placeholder character model while waiting for art to be completed. 
- Esugi#9867 - 3D modeller for Wisp, Fulmin, And Motes.
- Mirella#6691 - Animations
- Kenato123 On Reddit - For letting us use the Wisp artwork they made for the character select menu.
- PePe#1129 - 3D Model for Sol Gate Equipment and associated effects.
- The coding team: Popcorn Factory ->
    - Ethanol10#6656 - Main Programmer, I stuck my hands into all areas and I no longer have hands.
    - TeaL#5571 - Programmer -> Breach Surge, Mote functionality
    - BokChoyWithSoy#3842 - Programmer -> Will-O-Wisp skill state functionality, Achivements
- The Core devs on the modding discord, for answering my questions on mod dev, really helped me out! (Networking was a bitch, but I made it my bitch)

## Popcorn Factory

<details>
<summary>Check out other mods from the Popcorn Factory team!</summary>

<div>
    <a href="https://thunderstore.io/package/PopcornFactory/DarthVaderMod/">
      <img width="130" src="https://user-images.githubusercontent.com/93917577/180753359-4906ca0b-6ce5-4ff7-9962-bdec3329682c.png"/>
      <p>Darth Vader Mod (Popcorn Factory)</p>
    </a>
</div>
<div>
    <a href="https://thunderstore.io/package/PopcornFactory/DittoMod/">
        <img src="https://user-images.githubusercontent.com/93917577/168004690-23b6d040-5f89-4b62-916b-c40d774bff02.png"><br>
        <p>DittoMod (TeaL)</p>
    </a>
</div>
<div>
    <a href="https://thunderstore.io/package/PopcornFactory/ShigarakiMod/">
        <img src="https://user-images.githubusercontent.com/93917577/168004591-39480a52-c7fe-4962-997f-cd9460bb4d4a.png"><br>
        <p>ShigarakiMod (TeaL)</p>
    </a>
</div>
<div>
    <a href="https://thunderstore.io/package/TeaL/DekuMod/">
        <img src="https://cdn.discordapp.com/attachments/399901440023330816/960043614036168784/TeaL-DekuMod-3.1.1.png.128x128_q95.png"><br>
        <p>DekuMod (TeaL)</p>
    </a>
</div>
<div>
    <a href="https://thunderstore.io/package/Ethanol10/Ganondorf_Mod/">
        <img src="https://cdn.discordapp.com/attachments/399901440023330816/960043613428011079/Ethanol10-Ganondorf_Mod-2.1.5.png.128x128_q95.png"><br>
        <p>Ganondorf Mod (Ethanol 10)</p>
    </a>
</div>
<div>
    <a href="https://thunderstore.io/package/BokChoyWithSoy/Phoenix_Wright_Mod/">
        <img src="https://cdn.discordapp.com/attachments/399901440023330816/960054458790850570/BokChoyWithSoy-Phoenix_Wright_Mod-1.6.2.png.128x128_q95.png"><br>
        <p>Phoenix Wright Mod (BokChoyWithSoy)</p>
    </a>
</div>
<div>
    <a href="https://thunderstore.io/package/PopcornFactory/Rimuru_Tempest_Mod/">
        <img width="130" src="https://raw.githubusercontent.com/Ethanol10/rimuru-tempest-ror2/master/ReleaseFolder/Icon.png"><br>
        <p>Rimuru Tempest Mod (Popcorn Factory)</p>
    </a>
</div>

</details>